package com.gic.haoban.manage.web.controller.hm;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.haoban.base.api.common.PageResult2;
import com.gic.haoban.base.api.common.pojo.dto.WebLoginDTO;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.hm.HmPageQueryDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageRelationQueryDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageRelationRespDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageTemplateDTO;
import com.gic.haoban.manage.api.dto.hm.HmPageTemplateRespDTO;
import com.gic.haoban.manage.api.service.hm.HmPageTemplateApiService;
import com.gic.haoban.manage.web.vo.hm.HmPageTemplateListVO;
import com.gic.haoban.manage.web.vo.hm.HmPageTemplateSettingVO;
import com.gic.haoban.manage.web.vo.hm.PageTemplateRelationVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author MUSI
 * @Date 2022/7/4 1:58 PM
 * @Description
 * @Version
 **/
@RestController
@RequestMapping(path = "/hm/guide")
public class HmPageTemplateController {

    @Autowired
    private HmPageTemplateApiService pageTemplateApiService;

    @RequestMapping(path = "/page/save")
    public RestResponse<?> savePageTemplate(HmPageTemplateSettingVO pageTemplateSettingVO){
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmPageTemplateDTO pageTemplateDTO = new HmPageTemplateDTO();
        pageTemplateDTO.setPageName(pageTemplateSettingVO.getTemplateName());
        pageTemplateDTO.setPageTitle(pageTemplateSettingVO.getPageTitle());
        pageTemplateDTO.setMerchantName(pageTemplateSettingVO.getMerchantName());
        pageTemplateDTO.setMerchantPhoneNumber(pageTemplateSettingVO.getMerchantPhoneNumber());
        pageTemplateDTO.setMerchantLogo(pageTemplateSettingVO.getMerchantLogo());
        pageTemplateDTO.setPageBackgroudImg(pageTemplateSettingVO.getPageBackgroundImg());
        pageTemplateDTO.setGuideComment(pageTemplateSettingVO.getGuideComment());
        pageTemplateDTO.setClerkId(loginUser.getClerkId());
        pageTemplateDTO.setClerkName(loginUser.getClerkName());
        pageTemplateDTO.setEnterpriseId(loginUser.getEnterpriseId());
        pageTemplateDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        ServiceResponse<Long> serviceResponse = pageTemplateApiService.saveOrUpdateHmPageTemplate(pageTemplateDTO);
        if (serviceResponse.isSuccess()){
            return RestResponse.successResult(serviceResponse.getResult());
        }
        return RestResponse.failure(serviceResponse.getCode()+"", serviceResponse.getMessage());
    }


    @RequestMapping(path = "/page/edit")
    public RestResponse<?> editPageTemplate(HmPageTemplateSettingVO pageTemplateSettingVO){
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmPageTemplateDTO pageTemplateDTO = new HmPageTemplateDTO();
        pageTemplateDTO.setPageId(pageTemplateSettingVO.getTemplateId());
        pageTemplateDTO.setPageName(pageTemplateSettingVO.getTemplateName());
        pageTemplateDTO.setPageTitle(pageTemplateSettingVO.getPageTitle());
        pageTemplateDTO.setMerchantName(pageTemplateSettingVO.getMerchantName());
        pageTemplateDTO.setMerchantPhoneNumber(pageTemplateSettingVO.getMerchantPhoneNumber());
        pageTemplateDTO.setMerchantLogo(pageTemplateSettingVO.getMerchantLogo());
        pageTemplateDTO.setPageBackgroudImg(pageTemplateSettingVO.getPageBackgroundImg());
        pageTemplateDTO.setGuideComment(pageTemplateSettingVO.getGuideComment());
        pageTemplateDTO.setClerkId(loginUser.getClerkId());
        pageTemplateDTO.setClerkName(loginUser.getClerkName());
        pageTemplateDTO.setEnterpriseId(loginUser.getEnterpriseId());
        pageTemplateDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        ServiceResponse<Long> serviceResponse = pageTemplateApiService.saveOrUpdateHmPageTemplate(pageTemplateDTO);
        if (serviceResponse.isSuccess()){
            return RestResponse.successResult(serviceResponse.getResult());
        }
        return RestResponse.failure(serviceResponse.getCode()+"", serviceResponse.getMessage());
    }

    @RequestMapping(path = "/page/list")
    public RestResponse<?> queryPageTemplateList(HmPageTemplateListVO pageTemplateListVO){

        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmPageQueryDTO hmPageQueryDTO = new HmPageQueryDTO();
        hmPageQueryDTO.setPageNum(pageTemplateListVO.getPageNum());
        hmPageQueryDTO.setPageSize(pageTemplateListVO.getPageSize());
        hmPageQueryDTO.setEnterpriseId(loginUser.getEnterpriseId());
        hmPageQueryDTO.setWxEnterpriseId(loginUser.getWxEnterpriseId());
        hmPageQueryDTO.setPageSearchText(pageTemplateListVO.getPageSearchText());
        hmPageQueryDTO.setStartTime(pageTemplateListVO.getStartTime());
        hmPageQueryDTO.setEndTime(pageTemplateListVO.getEndTime());
        ServiceResponse<Page<HmPageTemplateRespDTO>> serviceResponse = pageTemplateApiService.queryPageTemplateList(hmPageQueryDTO);
        PageResult2 pageInfo = PageUtil.getPageInfo(serviceResponse.getResult());
        return RestResponse.successResult(pageInfo);
    }

    @RequestMapping(path = "/page/delete")
    public RestResponse<?> deletePageTemplate(Long templateId){
        WebLoginDTO loginUser = AuthWebRequestUtil.getLoginUser();
        HmPageTemplateDTO hmPageTemplateDTO = new HmPageTemplateDTO();
        hmPageTemplateDTO.setPageId(templateId);
        hmPageTemplateDTO.setClerkId(loginUser.getClerkId());
        hmPageTemplateDTO.setClerkName(loginUser.getClerkName());
        ServiceResponse<Boolean> serviceResponse = pageTemplateApiService.deleteHmPageTemplate(hmPageTemplateDTO);
        if (serviceResponse.isSuccess()){
            return RestResponse.successResult(serviceResponse.getResult());
        }
        return RestResponse.failure(serviceResponse.getCode()+"", serviceResponse.getMessage());
    }

    @RequestMapping(path = "/page/detail")
    public RestResponse<?> queryPageTemplateDetail(Long templateId){
        ServiceResponse<HmPageTemplateRespDTO> serviceResponse = pageTemplateApiService.queryPageTemplateDetail(templateId);
        return RestResponse.successResult(serviceResponse.getResult());
    }

    @RequestMapping(path = "/page/relation")
    public RestResponse<?> queryPageTemplateRelationList(PageTemplateRelationVO pageTemplateRelationVO){
        HmPageRelationQueryDTO pageRelationQueryDTO = new HmPageRelationQueryDTO();
        pageRelationQueryDTO.setPageNum(pageTemplateRelationVO.getPageNum());
        pageRelationQueryDTO.setPageSize(pageTemplateRelationVO.getPageSize());
        pageRelationQueryDTO.setSearchText(pageTemplateRelationVO.getSearchContent());
        pageRelationQueryDTO.setPageId(pageRelationQueryDTO.getPageId());
        ServiceResponse<Page<HmPageRelationRespDTO>> serviceResponse = pageTemplateApiService.queryPageRelation(pageRelationQueryDTO);
        PageResult2 pageInfo = PageUtil.getPageInfo(serviceResponse.getResult());
        return RestResponse.successResult(pageInfo);
    }
}
